import { DlzControlTowerControlFormat, IDlzControlTowerControl, DlzControlTowerStandardControls } from '../index';
/**
 * This control detects whether MFA is enabled for AWS IAM users.
 *
 * Format: Legacy Control
 * https://docs.aws.amazon.com/controltower/latest/userguide/elective-controls.html#disallow-access-mfa
 */
export declare class AWS_GR_MFA_ENABLED_FOR_IAM_CONSOLE_ACCESS implements IDlzControlTowerControl {
    readonly controlFriendlyName = DlzControlTowerStandardControls['AWS_GR_MFA_ENABLED_FOR_IAM_CONSOLE_ACCESS'];
    readonly description = "This control detects whether MFA is enabled for AWS IAM users.";
    readonly format = DlzControlTowerControlFormat.LEGACY;
    readonly externalLink = "https://docs.aws.amazon.com/controltower/latest/userguide/elective-controls.html#disallow-access-mfa";
    readonly controlIdName: {
        euWest1: string;
        usEast1: string;
    };
}
