import { DlzControlTowerControlFormat, IDlzControlTowerControl, DlzControlTowerStandardControls } from '../index';
/**
 * Secure your AWS accounts by disallowing account access with root user credentials, which are credentials of the
 * account owner and allow unrestricted access to all resources in the account. We recommend that you instead
 * create AWS Identity and Access Management (IAM) users for everyday interaction with your AWS account.
 *
 * Format: Legacy Control
 * https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#disallow-root-auser-actions
 */
export declare class AWS_GR_RESTRICT_ROOT_USER implements IDlzControlTowerControl {
    readonly controlFriendlyName = DlzControlTowerStandardControls['AWS_GR_RESTRICT_ROOT_USER'];
    readonly description = "Secure your AWS accounts by disallowing account access with root user credentials, which are credentials of the account owner and allow unrestricted access to all resources in the account.";
    readonly format = DlzControlTowerControlFormat.LEGACY;
    readonly externalLink = "https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#disallow-root-auser-actions";
    readonly controlIdName: {
        euWest1: string;
        usEast1: string;
    };
}
