import { DlzControlTowerStandardControls, DlzControlTowerControlFormat, IDlzControlTowerControl } from '../';
/**
 * This control checks whether your secrets have been accessed within a specified number of days. The default value
 * is 90 days. Secrets that have not been accessed even once within the number days you define, fail this check.
 *
 * Format: Standard Control
 * Owner: Security Hub
 * https://docs.aws.amazon.com/securityhub/latest/userguide/secretsmanager-controls.html#secretsmanager-3
 * */
export declare class SH_SECRETS_MANAGER_3 implements IDlzControlTowerControl {
    readonly controlFriendlyName = DlzControlTowerStandardControls['SH_SECRETS_MANAGER_3'];
    readonly description = "This control checks whether your secrets have been accessed within a specified number of days.";
    readonly format = DlzControlTowerControlFormat.STANDARD;
    readonly externalLink = "https://docs.aws.amazon.com/securityhub/latest/userguide/secretsmanager-controls.html#secretsmanager-3";
    readonly controlIdName: {
        euWest1: string;
        usEast1: string;
    };
}
