import { App } from 'aws-cdk-lib';
import { AuditStacks, DataLandingZoneProps, LogStacks } from './data-landing-zone-types';
import { ManagementStack, WorkloadGlobalNetworkConnectionsPhase1Stack } from './stacks';
import { WorkloadGlobalStack } from './stacks/organization/workloads/base/global-stack';
import { WorkloadRegionalStack } from './stacks/organization/workloads/base/regional-stack';
import { WorkloadGlobalDataServicesPhase1Stack } from './stacks/organization/workloads/data-services-phase-1-stack/global-stack';
import { WorkloadRegionalDataServicesPhase1Stack } from './stacks/organization/workloads/data-services-phase-1-stack/regional-stack';
import { WorkloadGlobalNetworkConnectionsPhase2Stack } from './stacks/organization/workloads/network-connections-phase-2-stack/global-stack';
import { WorkloadRegionalNetworkConnectionsPhase2Stack } from './stacks/organization/workloads/network-connections-phase-2-stack/regional-stack';
import { WorkloadGlobalNetworkConnectionsPhase3Stack } from './stacks/organization/workloads/network-connections-phase-3-stack/global-stack';
import { WorkloadRegionalNetworkConnectionsPhase3Stack } from './stacks/organization/workloads/network-connections-phase-3-stack/regional-stack';
export declare class DataLandingZone {
    private app;
    private props;
    private pipeline;
    managementStack: ManagementStack;
    logStacks: LogStacks;
    auditStacks: AuditStacks;
    workloadGlobalStacks: WorkloadGlobalStack[];
    workloadRegionalStacks: WorkloadRegionalStack[];
    workloadGlobalNetworkConnectionsPhase1Stacks: WorkloadGlobalNetworkConnectionsPhase1Stack[];
    workloadGlobalNetworkConnectionsPhase2Stacks: WorkloadGlobalNetworkConnectionsPhase2Stack[];
    workloadRegionalNetworkConnectionsPhase2Stacks: WorkloadRegionalNetworkConnectionsPhase2Stack[];
    workloadGlobalNetworkConnectionsPhase3Stacks: WorkloadGlobalNetworkConnectionsPhase3Stack[];
    workloadRegionalNetworkConnectionsPhase3Stacks: WorkloadRegionalNetworkConnectionsPhase3Stack[];
    workloadGlobalDataServicesPhase1Stacks: WorkloadGlobalDataServicesPhase1Stack[];
    workloadRegionalDataServicesPhase1Stacks: WorkloadRegionalDataServicesPhase1Stack[];
    private globalVariables;
    constructor(app: App, props: DataLandingZoneProps);
    stageManagement(): ManagementStack;
    private stageLog;
    private stageAudit;
    private stageWorkloadGlobalStacks;
    private stageWorkloadRegionalStacks;
    private stageWorkloadGlobalNetworkConnectionsPhase1Stacks;
    private stageWorkloadGlobalNetworkConnectionsPhase2Stack;
    private stageWorkloadRegionalNetworkConnectionsPhase2Stack;
    private stageWorkloadGlobalNetworkConnectionsPhase3Stack;
    private stageWorkloadRegionalNetworkConnectionsPhase3Stack;
    private stageWorkloadGlobalDataServicesPhase1Stack;
    private stageWorkloadRegionalDataServicesPhase1Stack;
    private accountStageName;
}
export default DataLandingZone;
