import { DLzAccount, DlzRegions, OrgOuSecurity } from '../../data-landing-zone-types';
export declare enum ReportType {
    CONTROL_TOWER_CONTROL = "Control Tower Control",
    CONFIG_RULE = "Config Rule",
    SECURITY_HUB_STANDARD = "SecurityHub Standard",
    TAG_POLICY = "Tag Policy",
    SERVICE_CONTROL_POLICY = "Service Control Policy"
}
export interface ReportResource {
    readonly type: ReportType;
    readonly name: string;
    readonly description: string;
    readonly externalLink: string;
}
/**
 * Behavioral, used with Inheritance
 */
export interface IReportResource {
    readonly reportResource: ReportResource;
}
export interface ReportItem extends ReportResource {
    readonly accountName: string;
    readonly appliedFrom: 'account' | 'ou';
    readonly region: string;
}
export interface PartialOu {
    readonly ouId: string;
    readonly accounts?: DLzAccount[];
}
export declare class Report {
    static reports: ReportItem[];
    static addReportForAccountRegion(accountName: string, region: string, reportResource: ReportResource): void;
    static addReportForAccountRegions(accountName: string, regions: DlzRegions, reportResource: ReportResource): void;
    static addReportForSecurityOuAccountRegions(securityOu: OrgOuSecurity, regions: DlzRegions, reportResource: ReportResource): void;
    static addReportForOuAccountRegions(partialOu: PartialOu, regions: DlzRegions, reportResource: ReportResource): void;
    static printConsoleReport(): void;
    static saveConsoleReport(): void;
    private static groupByAccountTypeNameAggregatedRegions;
}
